// filehand.c (C) 2000 Jay Cook
// The part where it handles all the file routines for mazes
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <mem.h>
#include <alloc.h>
#include <fcntl.h>     // open()
#include <sys\stat.h>  // open()
#include <io.h>        // chsize()
void LoadMaze();
void SaveMaze();
void SaveNewMaze();
void CheckNumber();
void DeleteMaze();
void SendMMapName();

 struct MazeInfo
 {
  char name[20];
  int MazeMap[805];
 } Maze;

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;

FILE *fptr;

int p, MaxNumber;
long int offset;

void LoadMaze(int FileNumber)
{ // Loads maze from disk
 if( (fptr=fopen("maze.dat", "rb"))==NULL)
    QuitDos(1, "Maze file not found!", "maze.dat");
                
 offset = (FileNumber-1) * sizeof(struct MazeInfo);
 if(fseek(fptr, offset, 0) !=0)
    QuitDos(1, "Error in maze file", "maze.dat");
 fread(&Maze, sizeof(struct MazeInfo),1,fptr);
 fclose(fptr);
}

void CheckNumber()
{ // Checks how many mazes are on disk
 if( (fptr=fopen("maze.dat", "rb"))==NULL)
    QuitDos(1, "Can't open file", "maze.dat");
 p=0;
 while( fread(&Maze, sizeof(struct MazeInfo),1,fptr)==1)
 {
  p++;
 }
 fclose(fptr);
 return(p);
}

void CNumber()
{ // Checks how many mazes are on disk
 if( (fptr=fopen("maze.dat", "rb"))==NULL)
    QuitDos(1, "Can't open file", "maze.dat");
 MaxNumber=0;
 while( fread(&Maze, sizeof(struct MazeInfo),1,fptr)==1)
 {
  MaxNumber++;
 }
 fclose(fptr);
}

void SaveNewMaze()
{ // saves maze to disk
 if( (fptr=fopen("maze.dat","ab"))==NULL)
    QuitDos(1, "Can't open file", "maze.dat");
  fwrite(&Maze, sizeof(struct MazeInfo),1,fptr);
 fclose(fptr);
}

void SaveMaze(int FileNumber)
{ // saves maze to disk
 if( (fptr=fopen("maze.dat","r+b"))==NULL)
    QuitDos(1, "Can't open file", "maze.dat");
 offset = (FileNumber-1) * sizeof(struct MazeInfo);
  fseek(fptr, offset, SEEK_SET);
  fwrite(&Maze, sizeof(struct MazeInfo),1,fptr);
 ///////////////////////
 fclose(fptr);
}

void SendMMapName(char MMName[19])
{
 strcpy(Maze.name, MMName);
}

void SendMapInfo()
{ // Gets info from map maker
 for(p=0;p<800;p++)
 {             
  Maze.MazeMap[p]=SendMapInfo1(p);
 }
}

void GetMaName()
{
 GetDaName(Maze.name);
}

void GetMaName2()
{
 GetDaName2(Maze.name);
}

int GetMapInfo1(int n)
{ // send map info to maker
 return Maze.MazeMap[n];
}

void DeleteMaze(int FileNumber)
{ // Loads maze from disk
 int handle;
 CNumber();
 if( (fptr=fopen("maze.dat", "r+b"))==NULL)
    QuitDos(1, "Maze file not found!", "maze.dat");                
 if(MaxNumber<2)
 { // make sure there is at least one maze in the stack
  DrawMouseBG();
  DrawBlock(0,160,320,40,8);
  GFont(12,21,"Can't delete Maze!");
  GFont(1,22,"You need at least one maze in the stack");
  GFont(12,24,"   Hit any key");
  WaitVR();
  getch();
  return;
 }
 for(p=(FileNumber-1);p<(MaxNumber+1);p++)
 {
   // Loads maze after the current one
   offset = (p+1) * sizeof(struct MazeInfo);
   fseek(fptr, offset, 0);
   fread(&Maze, sizeof(struct MazeInfo),1,fptr);
   // copies maze to new space(one below)
   offset = (p) * sizeof(struct MazeInfo);
   fseek(fptr, offset, SEEK_SET);
   fwrite(&Maze, sizeof(struct MazeInfo),1,fptr);
  fseek(fptr, offset, SEEK_SET);
  fwrite(&Maze, sizeof(struct MazeInfo),1,fptr);

 }
 fclose(fptr);
 // cuts the file size down
 handle = open("maze.dat", O_WRONLY, O_BINARY);
 chsize(handle, sizeof(struct MazeInfo)*(MaxNumber-1));
 close(handle);

}
