// Maze.c (C) 2000 Jay Cook
// Main functions, runs the game
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <mem.h>
#include <alloc.h>
#define MazeVer ".45"
#define MazeDate "04-12-00"

void YesNo(); 
void Menu(); 
int QuitMenu();
void QuitDos();
void KBSelectYN();
void KBSelectMenu();
void DoMarq();
void CheckMenuOK(int MenuPosX, int MenuPosY);
int MenuOK(int MenuX,int MenuY, int StateOfGame);

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;


int key, Menu1, GameState, MenuO, J, YesNoQ, pp, MarqNum, MarqMax, TMenuX, TMenuY;
char Marq[]={"Welcome to Mazeopolis, a game created by Jay Cook (C) 2000. Check out my webpage at ziel.tripod.com and if you want to contact me you can do so at jaycook1@juno.com ... Enjoy!                      "};

int MenuOK(int MenuX,int MenuY, int StateOfGame)
{
 TMenuX=MenuX*8-10;
 TMenuY=MenuY*8-9;
 DrawBlock(MenuX*8-10, MenuY*8-9,21,11,15);
 DrawBlock(MenuX*8-9, MenuY*8-8,20,10,8);
 DrawBlock(MenuX*8-9, MenuY*8-8,19,9,7);
 GFont(MenuX,MenuY,"OK");
 GetMouseBG();
 WaitVR();
 Menu1=0;
 GameState=7;
 do
 {
  if(kbhit())
  {
   key=getch();
   if(key>0) Menu1=1;
  }
  GetMouse();
  DrawMouseBG();
  GetMouseBG();
  DrawMouseCursor();
  WaitVR();
 }
 while(Menu1!=1);
 GameState=StateOfGame;
}

void CheckMenuOK(int MenuPosX, int MenuPosY)
{
 if(MenuPosX > TMenuX && MenuPosX < TMenuX+21 && MenuPosY > TMenuY && MenuPosY < TMenuY + 11)
  Menu1=1;
}

int YesNoMenu()
{ // Puts yes and no, gets input for it, and returns answere
 Menu1=0;
 MenuO=2;
 GameState=2;
 GFont(15,23,"Yes    No");
 GetMouseBG();
 do
 {
  GetMouse();
  DrawMouseBG();
  KBSelectYN();
  GetMouseBG();
  DrawMouseCursor();
  WaitVR();
 } while(Menu1!=1);
 GameState=1;
 if(MenuO==1) return(1);
 if(MenuO==2) return(2);
 DrawMouseBG();
 return;
}

void KBSelectYN()
{
  DrawBlock(98+(58*MenuO-58),176,8,8,8);
  if(kbhit())
  {
   key=getch();
   switch(key)
   {
     case 75:
     {
      MenuO--;
      if(MenuO<1)MenuO=2;
     } break;
     case 77:
     {
      MenuO++;
      if(MenuO>2)MenuO=1;
     } break;
     case 13: Menu1=1; break;
   }
  }
  DoSpriteNum(98+(58*MenuO-58),176,9);
}

void SetGameState(int GameStateNew)
{
 GameState=GameStateNew;
}

void YesNo(int YNX, int YNY)
{ // Mouse buttons for yes no question
 if(YNX > 112 && YNX < 136 && YNY > 176 && YNY < 184)
 {
  MenuO=1;
  Menu1=1;
 }
 if(YNX > 168 && YNX < 180 && YNY > 176 && YNY < 184)
 {
  MenuO=2;
  Menu1=1;
 }
}


void GameMenu()
{
 GameState=3;
 Menu1=0;
 pp=8;
 MarqNum=0;
 MarqMax=strlen(Marq);
 CLS();
 GFont(15,5,"Mazeopolis");
 GFont(15,15,"Start Game");
 GFont(18,17,"Quit");
 GFont(15,19,"Maze Maker");
 GetMouseBG();
 MenuO=1;
 do
 {
  GetMouse();
  DrawMouseBG();
  DoMarq();
  KBSelectMenu();
  GetMouseBG();
  DrawMouseCursor();
  WaitVR();
 } while(Menu1!=1);
 if(MenuO==1) GameState=1;
 if(MenuO==2) GameState=10;
 if(MenuO==3) GameState=4;
}

void KBSelectMenu()
{
  DrawBlock(100,112+(16*MenuO-16),8,8,0);
  if(kbhit())
  {
   key=getch();
   switch(key)
   {
     case 72:
     {
      MenuO--;
      if(MenuO<1)MenuO=3;
     } break;
     case 80:
     {
      MenuO++;
      if(MenuO>3)MenuO=1;
     } break;
     case 13: Menu1=1; break;
   }
  }
  DoSpriteNum(100,112+(16*MenuO-16),9);
}

void Menu(int MenuX, int MenuY)
{ // Mouse buttons for main menu
 if(MenuX > 112 && MenuX < 192 && MenuY > 112 && MenuY < 120)
 { // Start
  Menu1=1;
  MenuO=1;
 }
 if(MenuX > 128 && MenuX < 160 && MenuY > 128 && MenuY < 136)
 { // Quit
  Menu1=1;
  MenuO=2;
 }
 if(MenuX > 112 && MenuX < 200 && MenuY > 144 && MenuY < 152)
 { // Maze Maker
  Menu1=1;
  MenuO=3;
 }
}

void main()
{
 set_mode(0x13); 
 SetBuffer();
 GetSprites();
 SetupMouse();
 GameState=3;
 do
 {
  switch(GameState)
  {
   case 1: { DoMaze(0); DrawMaze(); GameLoop();} break;
   case 3: GameMenu(); break;
   case 4: MazeMaker(); break;
   case 5: GameLoop(); break;
  }
 } while(GameState!=10);
 QuitDos(0,"None", "None");
}

void WinGame()
{
 GameState=6;
 DrawMouseBG();
 GFont(2,10,"Congratulations, you've won the maze!!!");
 MenuOK(20,12,6);
 GameState=3;
}

void DoRestart(int NewNumber)
{
 DrawMouseBG();
 DrawBlock(0,160,320,40,8);
 GFont(11,21,"Restart this level?");
 YesNoQ=YesNoMenu();
 if(YesNoQ==1)
 {
   DoMaze(NewNumber);
   DrawMaze();
 }
 GetMouseBG();
 MazeBar();
 GameState=5;
 return;
}

int QuitMenu(int StateGet)
{
 DrawMouseBG();
 DrawBlock(0,160,320,40,8);
 GFont(13,21,"Quit to menu?");
 YesNoQ=YesNoMenu();
 if(YesNoQ==1)
 {
  GameState=3;
  return 1;
 }
 GetMouseBG();
 GameState=StateGet;
 if (GameState==4) MapBar();
 if (GameState==5) MazeBar();
 return;
}

void CheckMouse(int ButtonX, int ButtonY)
{    // Where mouse is when button is hit
 switch(GameState)
 {
  case 2: YesNo(ButtonX, ButtonY); break;
  case 3: Menu(ButtonX, ButtonY); break;
  case 4: Maker(ButtonX, ButtonY); break;
  case 5: InGame(ButtonX, ButtonY); break;
  case 7: CheckMenuOK(ButtonX, ButtonY); break;
 }
}

void QuitDos(int ErrNum, char ErrMsg[40], char FileNam1[11])
{  // Quits back to dos, sets all stuff back up, prints an error message
 FreeSprites();
 FreeFont();
 freemem;                        // frees memory
 set_mode(0x03);                 /* set the video mode back to text mode. */
 if (ErrNum == 0)
 { // Prints out exit screen
  //textcolor(15);
  printf("\n\n Mazeopolis\n ------------------");
  printf("\n   Compiled with: Turbo C++ 3.0");
  printf("\n   Date compiled: %s",MazeDate);
  printf("\n   version %s", MazeVer);
  printf("\n   Copyright 2000 Jay Cook");
  printf("\n\n");
 }
 if (ErrNum == 1)
 {  // Prints error message if it quits bad
  printf("\n **** ERROR ****");
  printf("\nError Message: %s\n",ErrMsg);
  printf("Error file: %s\n\n",FileNam1);
 }
 exit(1);
}

void DoMarq()
{ // Marqie at the bottom of the screen
 if(pp==8)
 {
  pp=0;
  GCFont(39,23,Marq[MarqNum]);
  CopyChar1();
  MarqNum++;
  if(MarqNum>MarqMax-1)MarqNum=0;
 }
 Scrollie();
 pp++;
}
